/*
 * Boost Software License - Version 1.0 - August 17th, 2003
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * 
 */

#ifndef WSTP_DECLARES_H
#define WSTP_DECLARES_H

#include "m.h"

#define MATHEMATICA_DECLARE(F) namespace mathematica{ \
template <typename... T> \
mathematica::m F(T... args){return mathematica::m(#F)(args...);} \
}


// namespace mathematica{
// template <typename... T>
// mathematica::m Power(T... args){return mathematica::m("Power")(args...);}
// }

MATHEMATICA_DECLARE(Import)
MATHEMATICA_DECLARE(List)
MATHEMATICA_DECLARE(Total)
MATHEMATICA_DECLARE(Power)
MATHEMATICA_DECLARE(Surd)
MATHEMATICA_DECLARE(Sqrt)
MATHEMATICA_DECLARE(CubeRoot)
MATHEMATICA_DECLARE(Exp)
MATHEMATICA_DECLARE(Log)
MATHEMATICA_DECLARE(Log10)
MATHEMATICA_DECLARE(Log2)
MATHEMATICA_DECLARE(Factorial)
MATHEMATICA_DECLARE(FactorInteger)
MATHEMATICA_DECLARE(Sin)
MATHEMATICA_DECLARE(Cos)
MATHEMATICA_DECLARE(Tan)
MATHEMATICA_DECLARE(ArcSin)
MATHEMATICA_DECLARE(ArcCos)
MATHEMATICA_DECLARE(ArcTan)
MATHEMATICA_DECLARE(Csc)
MATHEMATICA_DECLARE(Sec)
MATHEMATICA_DECLARE(Cot)
MATHEMATICA_DECLARE(Max)
MATHEMATICA_DECLARE(Min)
MATHEMATICA_DECLARE(Solve)
MATHEMATICA_DECLARE(NSolve)
MATHEMATICA_DECLARE(Maximize)
MATHEMATICA_DECLARE(NMaximize)
MATHEMATICA_DECLARE(Minimize)
MATHEMATICA_DECLARE(NMinimize)

#endif // WSTP_DECLARES_H
